﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace DemoApp
{
    public class ViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        List<CustomClass> _list = new List<CustomClass>();
        List<CustomClass> _list2 = new List<CustomClass>();

        public ViewModel()
        {
            List = CreateList();
            List2 = CreateList();
        }

        public List<CustomClass> List
        {
            get
            {
                return _list;
            }
            set
            {
                if (_list != value)
                {
                    _list = value;
                    string name = null;
                    if (CurrentItem != null)
                    {
                        name = CurrentItem.Name;
                    }
                    if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs("List"));
                    if (name != null)
                        CurrentItem = _list.FirstOrDefault(result => result.Name == name);
                }
            }
        }

        private List<CustomClass> CreateList()
        {
            List<CustomClass> list = new List<CustomClass>();
            for (int i =0; i < 10000; i++)
            {
                var item1 = new CustomClass { ID = i+"", Name = "Name: " + i, Description = "Description: " + i };
                list.Add(item1);
            }
            return list;
        }

        private string _lastItem1;
        public string LastItem1
        {
            get { return _lastItem1; }
            set
            {
                if (_lastItem1 != value)
                {
                    _lastItem1 = value;
                    RefreshList2();
                }
            }
        }


        private CustomClass _currentItem;
        public CustomClass CurrentItem
        {
            get { return _currentItem; }
            set
            {
                if (_currentItem != value)
                {
                    _currentItem = value;
                    if (_currentItem != null) LastItem1 = _currentItem.Name;
                    if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs("CurrentItem"));
                }
            }
        }

        public void RefreshList1()
        {
            List<CustomClass> newList = new List<CustomClass>();
            foreach (var item in _list)
            {
                CustomClass customClass = new CustomClass();
                customClass.ID = item.ID;
                customClass.Name = item.Name;
                customClass.Description = item.Description;
                newList.Add(customClass);
            }
            List = newList;
        }

        public void RefreshList2()
        {
            List<CustomClass> newList = new List<CustomClass>();
            foreach (var item in _list2)
            {
                CustomClass customClass = new CustomClass();
                customClass.ID = item.ID;
                customClass.Name = item.Name;
                customClass.Description = item.Description;
                newList.Add(customClass);
            }
            List2 = newList;
        }

        public List<CustomClass> List2
        {
            get { return _list2; }
            set
            {
                if (_list2 != value)
                {
                    _list2 = value;
                    string name = null;
                    if (CurrentItem2 != null)
                    {
                        name = CurrentItem2.Name;
                    }
                    if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs("List2"));
                    if (name != null)
                        CurrentItem2 = _list2.FirstOrDefault(result => result.Name == name);
                }
            }
        }

        private string _lastItem2;
        public string LastItem2
        {
            get { return _lastItem2; }
            set
            {
                if (_lastItem2 != value)
                {
                    _lastItem2 = value;
                    RefreshList1();
                }
            }
        }

        private CustomClass _currentItem2;
        public CustomClass CurrentItem2
        {
            get { return _currentItem2; }
            set
            {
                if (_currentItem2 != value)
                {
                    _currentItem2 = value;

                    if (_currentItem2 != null) LastItem2 = _currentItem2.Name;
                    if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs("CurrentItem2")); 
                }
            }
        }
    }
}
